package com.akamai.hdcore.samples.utility
{
    import flash.display.Sprite;
    import flash.display.StageDisplayState;
    import flash.media.Video;
    
    import org.openvideoplayer.components.ui.debug.DebugPanelView;
    
    public class Utils
    {
        public static const SCALE_MODE_FIT:String = "fit";
        public static const SCALE_MODE_NATIVE:String = "native";
        /**
         *
         */
        public static var console:DebugPanelView;
        
        /**
         *
         * @param sec
         * @return
         *
         */
        public static function convertToTimeCode(sec:Number):String
        {
            var h:Number = Math.floor(sec / 3600);
            var m:Number = Math.floor((sec % 3600) / 60);
            var s:Number = Math.floor((sec % 3600) % 60);
            return (h == 0 ? "" : (h < 10 ? "0" + h.toString() + ":" : h.toString() + ":")) + (m < 10 ? "0" + m.toString() : m.toString()) + ":" + (s < 10 ? "0" + s.toString() : s.toString());
        }
        
        /**
         *
         * @param data
         *
         */
        public static function traceMetaData(data:Object):void
        {
            var str:String;
            
            for (var propName:String in data)
            {
                str = "metadata: " + propName + " = " + data[propName];
                
                if (console != null)
                {
                    console.log(str);
                }
                else
                {
                    trace(str);
                }
            }
        }
        
        public static function scaleVideo(view:Sprite, w:Number, h:Number):void
        {
            var video:Video;
            
            if (view is MediaPlayerView)
            {
                video = MediaPlayerView(view).video;
            }
            
            if (video != null)
            {
                if (w / h >= 4 / 3)
                {
                    video.width = 480;
                    video.height = 480 * h / w;
                }
                else
                {
                    video.width = view.width * w / h;
                    video.height = view.height;
                }
                video.x = (view.width - video.width) / 2;
                video.y = (view.height - video.height) / 2;
            }
        }
        
        public static function doScaleMode(view:Sprite, type:String, containerWidth:Number, containerHeight:Number):void
        {
            var video:Video;
            
            if (view is MediaPlayerView)
            {
                video = MediaPlayerView(view).video;
            }
            
            if (video is Video && view.stage.displayState != StageDisplayState.FULL_SCREEN)
            {
                switch (type)
                {
                    case SCALE_MODE_FIT:
                        if (video.videoWidth / video.videoHeight > view.width / containerHeight)
                        {
                            video.width = containerWidth;
                            video.height = containerWidth * video.videoHeight / video.videoWidth
                        }
                        else
                        {
                            video.height = containerHeight;
                            video.width = containerHeight * video.videoWidth / video.videoHeight;
                        }
                        video.smoothing = true;
                        break;
                    case SCALE_MODE_NATIVE:
                        video.width = video.videoWidth;
                        video.height = video.videoHeight;
                        
                        if (video.width > containerWidth || video.height > containerHeight)
                        {
                            video.opaqueBackground = null;
                        }
                        video.smoothing = false;
                        break;
                }
                
                video.x = Math.round((containerWidth - video.width) / 2)
                video.y = Math.round((containerHeight - video.height) / 2)
            }
        }
    }
}
