package com.akamai.player
{
	import com.akamai.hd.HDEvent;
	import com.akamai.hd.HDNetStream;
	
	import flash.display.Bitmap;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	
	public class HDMeter extends Sprite
	{
		private var bar0:Sprite;
		private var bar1:Sprite;
		private var bar2:Sprite;
		private var bar3:Sprite;
		private var ns:HDNetStream;
		private var enabledColor:ColorTransform;
		private var disabledColor:ColorTransform;
		private var unavailableColor:ColorTransform;
		private var clickLayer:Sprite;
		private var hdLogo:Bitmap;
		
		[Embed(source='../../../assets/images/hd.png')]
    	private static var hdPNG: Class;
		
		public function HDMeter()
		{
			super();
			init();
		}
		
		public function setNetStream(netstream:HDNetStream):void
		{
			ns = netstream;
			ns.addEventListener(HDEvent.PROGRESS,onProgress);
			ns.addEventListener(HDEvent.METADATA,onMetaData);
		}
		private function onMetaData(event:HDEvent):void
		{
			hdLogo.visible = Number(event.data.height.toString()) >= 720
			bar0.visible = bar1.visible = bar2.visible = bar3.visible = !hdLogo.visible 
		}
		private function onProgress(event:HDEvent):void
		{
			var d:Number = ns.maxIndexAvailable/4;
			for (var i:Number=0; i<4;i++)
			{
				if (i <= ns.maxIndexAvailable)
				{
					(this["bar"+i] as Sprite).transform.colorTransform = ns.currentIndex >= i*d ? enabledColor:disabledColor
				}
				else
				{
					(this["bar"+i] as Sprite).transform.colorTransform  = unavailableColor;
				}
			}
		}
		
		private function init():void
		{
			createChildren();
			this.useHandCursor = true;
			this.buttonMode = true;
			enabledColor = new ColorTransform();
			enabledColor.color = 0x00ff00;
			disabledColor = new ColorTransform();
			disabledColor.color = 0xaaaaaa;
			unavailableColor = new ColorTransform();
			unavailableColor.color = 0x555555;
		}
		private function createChildren():void
		{
			clickLayer = new Sprite();
			clickLayer.graphics.beginFill(0xaa0000,0);
			clickLayer.graphics.drawRect(0,0,30,30);
			clickLayer.addEventListener(MouseEvent.MOUSE_DOWN,onClick);
			addChild(clickLayer);
			for (var i:Number=0; i<4;i++)
			{
				this["bar"+i] = new Sprite();
				var g:Graphics = this["bar"+i].graphics;
				g.beginFill(0xffffff);
				g.drawRect(0,0,3,4+(i*5));
				this["bar"+i].x = 6 + (i*5);
				this["bar"+i].y = 25 - this["bar"+i].height;
				addChild(this["bar"+i]);
			}
			hdLogo = new hdPNG();
			hdLogo.visible = false;
			addChild(hdLogo);
			
		}
		private function onClick(event:MouseEvent):void
		{
			dispatchEvent(event);
		}
	}
}